<script>
  export let sessionId;
  let categories = [];
  let events = [];
  let connected = false;

  // fms theming support
  let selected = "bfemp";

  function onConnect(event) {
    categories = Object.keys(event.lookup).reduce((accumulator, key) => {
      const value = event.lookup[key];
      let category = accumulator.find(c => c.name === value.category);
      if (!category) {
        category = { name: value.category, objects: [] };
        accumulator.push(category);
      }
      value.name = key;
      category.objects.push(value);
      return accumulator;
    }, []);
  }

  function onUpdate(event) {
    for (const updated of event.updated) {
      for (const category of categories) {
        const object = category.objects.find(o => o.name === updated.name);
        if (object) {
          object.state = updated.state;
          break;
        }
      }
    }

    categories = [...categories];
    events.unshift(event);
  }

  function mapCategory(category) {
    const parts = category.name.split("-").map(c => c.toLowerCase().trim());
    console.log(parts);
    return ["object-container", ...parts].join(" ");
  }

  function removeCategory(category) {
    categories = categories.filter(c => c != category);
  }

  if (sessionId) {
    console.log(`Connecting to ${sessionId}`);
    const webSocket = new WebSocket(
      `wss://venus.emergencyx.de/fms/websocket/${sessionId}`
    );
    webSocket.onopen = () => {
      connected = true;
    };
    webSocket.onmessage = message => {
      const event = JSON.parse(message.data);
      console.log(event);
      if (event.type === "connect") {
        onConnect(event);
      } else if (event.type === "update") {
        onUpdate(event);
      }
    };
    webSocket.onerror = reason => {
      connected = false;
      console.log(reason);
    };
    webSocket.onclose = reason => {
      connected = false;
      console.log(reason);
    };
  }
</script>

{#if sessionId && connected}
  <div class="fms-header">
    <i class="fas fa-heartbeat" aria-hidden="true" />
    Verbunden mit {sessionId}
    <div class="form-group">
      <select bind:value={selected} class="form-control form-control-sm">
        <option value="bfemp">BFEMP</option>
        <option value="alternative">Alternative</option>
        <option value="lahmy">Lahmy</option>
      </select>
    </div>
  </div>
  <div class="fms-style-{selected}">
    <div class="col-12">
      {#each categories as category}
        <div class="w-100" style="break-inside: avoid;">
          <p class="lead mb-0">
            {category.name}
            <button
              type="button"
              class="close"
              aria-label="Close"
              on:click={removeCategory(category)}>
              <span aria-hidden="true">&times;</span>
            </button>
          </p>
          <div class={mapCategory(category)}>
            {#each category.objects as object}
              <div class="object">
                <div class="status status--{object.state}">
                  <span>{object.state}</span>
                </div>
                <span>{object.display}</span>
              </div>
            {/each}
          </div>
        </div>
      {/each}
    </div>
  </div>
{:else}
  <div class="container">
    <h2>FMS</h2>
    <p>
      Das FMS benötigt einen Client, der die Änderungen an den Server übertragt.
      Dazu kann der in der Bieberfelde Modifikation beiliegenden LogSyncer oder
      der neue EmergencyX FMS Client verwendet werden. Du kannst den Link zu
      dieser Seite mit deinen Mitspielern teilen. Änderungen werden in Echtzeit
      aktualisiert.
    </p>
    <h3>EmergencyX FMS Client</h3>
    <p>
      Die aktuelle Version des FMS Clients kann
      <a href="https://gitlab.com/emergencyx/fms/-/releases">
        hier heruntergeladen
      </a>
      werden.
    </p>
  </div>
{/if}
